<!DOCTYPE html5>
<html lang="en" dir="ltr">
  <head>
    <meta charset="utf-8">
    <title></title>
    <link rel="stylesheet" href="style.css"></link>
  </head>
  <body style="margin: 0px; padding: 0px; overflow: hidden;">
    <button id="pay-button" onclick="buttonPressed();" hidden>Pay</button>
  </body>
  <script>
    'use strict';

    /** 
    * Encodes strings into base64url. Unlike regular base64, it is safe to use in URLs.
    * It differs from base64 by having '+' replaced by '-' and '/' replaced by '_'.
    * see https://developer.mozilla.org/en-US/docs/Glossary/Base64
    **/
    function base64url(source) {
      let encodedSource = btoa(source);

      encodedSource = encodedSource.replace(/=+$/, '');
      encodedSource = encodedSource.replace(/\+/g, '-');
      encodedSource = encodedSource.replace(/\//g, '_');

      return encodedSource;
    }

    function forbiddenSituation(msg) {
      throw msg + "\nThis should NEVER happen and may be indicative of a serious problem. Please contact Planck Payments as soon as possible.";
    }


    const STATE_INITIALIZED = 0;
    const STATE_PAYMENT_STARTED = 1;
    const STATE_PAYMENT_SUCCEEDED = 2;
    const STATE_PAYMENT_FAILED = 3;
    const STATE_GENERIC_ERROR = -1;

    let state = undefined;

    function badTransition(newState) {
      let oldState = state;
      state = STATE_GENERIC_ERROR;
      forbiddenSituation(`Impossible state transition from ${oldState} to ${newState}`);
    }

    function setState(newState) {

      let button = document.getElementById('pay-button');
      button.hidden = false;
      
      switch (newState) {
        case STATE_INITIALIZED:
          button.innerHTML = `Pay &euro; ${paymentEuros}.${dEUR}${cEUR}${mEUR}`;            
          break;
        case STATE_PAYMENT_STARTED:
          button.innerHTML = "...";
          break;
        case STATE_PAYMENT_SUCCEEDED:
          button.innerHTML = "Open";
          break;
        case STATE_PAYMENT_FAILED:
          button.innerHTML = "Failure";
          break;
        case STATE_GENERIC_ERROR:
          button.innerHTML = "ERROR";
          break;
        default:
          forbiddenSituation("Reached impossible state transition.");
      }
      state = newState;
    }

    const urlParams = new URLSearchParams(window.location.search);

    const recipientID = urlParams.get('recipient');
    const productID = urlParams.get('product');
    const paymentValue = parseInt(urlParams.get('value'));

    if (! (paymentValue > 0 && paymentValue <= 30000) ) { //NOTE: this will be a check in the backend in final version
      setState(STATE_GENERIC_ERROR);
      throw `Invalid payment value ${urlParams.get('value')}, must be a natural number between 1 and 30k`;
    }

    const paymentEuros = Math.floor(paymentValue/1000);
    const dEUR = Math.floor(paymentValue / 100) % 10;
    const cEUR = Math.floor(paymentValue / 10) % 10;
    const mEUR = Math.floor(paymentValue / 1) % 10;

    setState(STATE_INITIALIZED);

    let receipt;

    

    function buttonPressed() {
      switch (state) {
        case STATE_INITIALIZED:
          setState(STATE_PAYMENT_STARTED);
          setTimeout(paymentSuccessful, 300);
          break;
        case STATE_PAYMENT_SUCCEEDED:
          sendReceipt();
          break;
        default:
          break;
      }

    };

    async function paymentSuccessful() {
      switch (state) {
        case STATE_PAYMENT_STARTED:
          setState(STATE_PAYMENT_SUCCEEDED);
          receipt = Object.freeze({
            paymentValue: paymentValue,
            recipientID: recipientID,
            productID: productID
          });
          sendReceipt();
          break;
        default:
          badTransition(STATE_PAYMENT_SUCCEEDED);
      }
    };

    async function sendReceipt() {
      window.top.postMessage(await makeJWT_mock(receipt), '*');
    }

    async function makeJWT_mock(receipt) {
      var header = {
        "alg": "MOCK",
        "typ": "JWT"
      };
      var encodedHeader = base64url(JSON.stringify(header)),
          encodedReceipt = base64url(JSON.stringify(receipt)),
          unsignedToken = encodedHeader + "." + encodedReceipt,
          signature = base64url("mock-signature");

      return unsignedToken + "." + signature;
    }
  </script>
</html>
